unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    DateTimePicker1: TDateTimePicker;
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure WndProc(var Msg: TMessage); override;
  public
    { Public declarations }
    Mynmhdr: NMHDr;
  end;

var
  Form1: TForm1;

implementation

uses commctrl;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  MyPnmhdr: PNMHDr;
begin
  Mynmhdr.hwndFrom:=DateTimePicker1.Handle;
  Mynmhdr.idFrom:=DateTimePicker1.Handle;
  Mynmhdr.code:=DTN_DROPDOWN;
  Mypnmhdr:=@Mynmhdr;
  DatetimePicker1.Perform(CN_NOTIFY,DateTimePicker1.Handle,Integer(Mypnmhdr));
end;

procedure TForm1.Button1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Caption:=format('Mouse at: X=%d,Y=%D',[X,Y]);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  mpt: TPoint;
  mInput: tagInput;
  mi: tagMouseInput;
begin
  mpt:=DateTimePicker1.ClientToScreen(Point(DatetimePicker1.Width-5,DatetimePicker1.Height div 2));
  SetCursorPos(mpt.X,mpt.Y);
  mi.dx:=0;
  mi.dy:=0;
  mi.time:=0;
  mi.dwFlags:=MOUSEEVENTF_LEFTDOWN;
  mi.mouseData:=0;
  mInput.mi:=mi;
  mInput.Itype:=INPUT_MOUSE;
  SendInput(1,mInput,SizeOf(mInput));
  mi.dx:=0;
  mi.dy:=30;
  mi.dwFlags:=MOUSEEVENTF_MOVE;
  mInput.mi:=mi;
  SendInput(1,mInput,SizeOf(mInput));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;

end;

procedure TForm1.WndProc(var Msg: TMessage);
var
  p: PNMHDr;
  function FindControl(Handle: THandle): String;
  var
    I: Integer;
  begin
    Result:='';
    for I:=0 to ControlCount-1 do
      if (Controls[I] is TWinControl) and (TWinControl(Controls[I]).Handle=Handle) then
      begin
        Result:=TWinControl(Controls[I]).Name;
        Break;
      end;
  end;
begin
  if Msg.Msg=WM_NOTIFY then
  begin
    Memo1.Lines.Add(format('Msg:%d,From:%d-%s,lParam:%d',[Msg.Msg,Msg.WParam,FindControl(Msg.WParam),Msg.LParam]));
    p:=Pointer(Msg.LParam);
    Memo1.Lines.Add(format('Notify Data: From:%d-%s,idCtrl:%d-%s,Code:%d',[p^.hwndFrom,FindControl(p^.hwndFrom),p^.idFrom,FindControl(p^.idFrom),p^.code]));
  end;
  inherited WndProc(Msg);
end;

end.
